//////////////////////////////////////////////////////////////////////
//																	//
// PROGRAM: SZABLON1 - WZR APLIKACJI ZGODNEJ Z WIN32				//
//																	//
//////////////////////////////////////////////////////////////////////


#define STRICT	// danie cisego przestrzegania
				// zgodnoci typw w programie
#include <windows.h>	// plik nagwkowy funkcji API
						// Windows
#include "resource.h"

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
						// Prototyp gwnej funkcji
						// obsugi gwnego okna programu


// Gwna funkcja programu:
int WINAPI WinMain(	HINSTANCE hInstance,	// uchwyt instancji 
											// programu
					HINSTANCE hPrevInstance,// 0
					PSTR szCmdLine,			// linia komend
					int iCmdShow)			// pocztkowy stan 
											// programu
{
	static char szAppName[]="Win1";
	HWND hwnd;			// uchwyt gwnego okna
	MSG  msg;			// struktura przechowujca messages
	WNDCLASS wndclass;	// struktura do konstruowania klasy okna

	// Tworzenie klasy gwnego okna:
	wndclass.style=CS_HREDRAW|CS_VREDRAW; // styl klasy okna
	wndclass.lpfnWndProc=WndProc;		  // nazwa gwnej procedury 
										  // sterujcej okna	
	wndclass.cbClsExtra=0;				  // dodatkowy obszar pamici
	wndclass.cbWndExtra=0;				  // dodatkowy obszar pamici
	wndclass.hInstance=hInstance;		  // instancja programu
	wndclass.hIcon=LoadIcon(NULL,IDI_APPLICATION); // ikona klasy okien
	wndclass.hCursor=LoadCursor(NULL,IDC_ARROW);   // ksztat kursora
	wndclass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
													// kolor ta
	wndclass.lpszMenuName=MAKEINTRESOURCE(IDR_MENU1); // przyczone MENU
	wndclass.lpszClassName=szAppName;				  // indywidualna nazwa
													  // klasy okna

	RegisterClass(&wndclass); // zarejestrowanie klasy
	
	hwnd=CreateWindow(
						szAppName, // Nazwa klasy okna
						"Szablon1",// Napis w  pasku tytuu
						WS_OVERLAPPEDWINDOW, // Styl okna
						CW_USEDEFAULT, // pooenie okna x
						CW_USEDEFAULT, // pooenie okna y
						CW_USEDEFAULT, // wysoko okna
						CW_USEDEFAULT, // szeroko okna
						NULL,          // uchwyt do okna rodzica
						NULL,		   // uchwyt do menu lub identy-
									   // fikator okna dziecka	
						hInstance,	   // uchwyt do instancji programu
						NULL		   // uchwyt do danych tworzcych okno
					 );
	ShowWindow(hwnd,iCmdShow);  // przygotuj okno do wywietlenia
	UpdateWindow(hwnd);			// wylij pierwszy komunikat WM_PAINT

	//////////////////////////////////////////////////////////////////////
	// Obsuga ptli komunikatw :										//
	//////////////////////////////////////////////////////////////////////
	while(GetMessage(&msg,NULL,0,0))									
	{																	
		TranslateMessage(&msg);											
		DispatchMessage(&msg);											
	}																	
	return msg.wParam;												
}		
// Gwna procedura obsugi komunikatw okna:
	
LRESULT CALLBACK WndProc(HWND hwnd,
						 UINT iMsg,
						 WPARAM wParam,
						 LPARAM lParam)
{
	HDC HDCPaint;            // uchwyt obszaru kontekstu  
							 // urzdzenia klienta
	PAINTSTRUCT PaintStruct; // informacja o malowaniu
	RECT rect;				 // wsprzdne obszaru prostoktnego 
	
	switch(iMsg)
	{
		case WM_COMMAND: // Komunikat przychodzcy po wybraniu 
						 // opcji menu itp
			switch(LOWORD(wParam))
			{
				// Wybrano opcj menu Plik->Koniec:
				case ID_PLIK_KONIEC:
					DestroyWindow(hwnd);
					return 0;
			}
			return 0;

		case WM_DESTROY: // Komunikat przychodzcy gdy okno 
						 // ma by zniszczone
			PostQuitMessage(0);
			return 0;

		case WM_PAINT:  // Komunikat przychodzi w przypadku koniecznoci
						// "odmalowania" lub namalowania okna
			// Wyma okno, uzyskaj kontekst urzdzenia:
			HDCPaint=BeginPaint(hwnd,&PaintStruct);
			// Pobierz rozmiary obszaru roboczego okna
			GetClientRect(hwnd,&rect);
			// Umie centralnie w oknie tekst:
			DrawText(HDCPaint,"Pozdrowienia",-1,&rect,
					 DT_SINGLELINE|DT_CENTER|DT_VCENTER);
			// Zakocz rysowanie
 			EndPaint(hwnd, &PaintStruct);
			return 0;
		default:
			return DefWindowProc(hwnd,iMsg,wParam,lParam);
	
	}
}